Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1353)
@@ -3622,14 +3628,14 @@
                 v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
                 flux_n    = v_comp * (                                       &
-                          ( 37.0 * ibit14 * adv_mom_5                        &
-                       +     7.0 * ibit13 * adv_mom_3                        &
-                       +           ibit12 * adv_mom_1                        &
+                          ( 37.0_wp * ibit14 * adv_mom_5                        &
+                       +     7.0_wp * ibit13 * adv_mom_3                        &
+                       +              ibit12 * adv_mom_1                        &
                           ) *                                                &
                                  ( u(k,j+1,i) + u(k,j,i)   )                 &
-                   -      (  8.0 * ibit14 * adv_mom_5                        &
-                       +           ibit13 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit14 * adv_mom_5                        &
+                       +              ibit13 * adv_mom_3                        &
                           ) *                                                &
                                  ( u(k,j+2,i) + u(k,j-1,i) )                 &
-                   +      (        ibit14 * adv_mom_5                        &
+                   +      (           ibit14 * adv_mom_5                        &
                           ) *                                                &
                                  ( u(k,j+3,i) + u(k,j-2,i) )                 &
@@ -3637,14 +3643,14 @@
 
                 diss_n    = - ABS ( v_comp ) * (                             &
-                          ( 10.0 * ibit14 * adv_mom_5                        &
-                       +     3.0 * ibit13 * adv_mom_3                        &
-                       +           ibit12 * adv_mom_1                        &
+                          ( 10.0_wp * ibit14 * adv_mom_5                        &
+                       +     3.0_wp * ibit13 * adv_mom_3                        &
+                       +              ibit12 * adv_mom_1                        &
                           ) *                                                &
                                  ( u(k,j+1,i) - u(k,j,i)  )                  &
-                   -      (  5.0 * ibit14 * adv_mom_5                        &
-                       +           ibit13 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit14 * adv_mom_5                        &
+                       +              ibit13 * adv_mom_3                        &
                           ) *                                                &
                                  ( u(k,j+2,i) - u(k,j-1,i) )                 &
-                   +      (        ibit14 * adv_mom_5                        &
+                   +      (           ibit14 * adv_mom_5                        &
                           ) *                                                &
                                  ( u(k,j+3,i) - u(k,j-2,i) )                 &
@@ -3661,29 +3667,29 @@
                 w_comp    = w(k-1,j,i) + w(k-1,j,i-1)
                 flux_d    = w_comp  * (                                      &
-                          ( 37.0 * ibit17 * adv_mom_5                        &
-                       +     7.0 * ibit16 * adv_mom_3                        &
-                       +           ibit15 * adv_mom_1                        &
+                          ( 37.0_wp * ibit17 * adv_mom_5                        &
+                       +     7.0_wp * ibit16 * adv_mom_3                        &
+                       +              ibit15 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k,j,i)    + u(k-1,j,i)   )                  &
-                   -      (  8.0 * ibit17 * adv_mom_5                        &
-                       +           ibit16 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit17 * adv_mom_5                        &
+                       +              ibit16 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k+1,j,i) + u(k_mm,j,i)   )                  &
-                   +      (        ibit17 * adv_mom_5                        &
-                          ) *                                                &
+                   +      (           ibit17 * adv_mom_5                        &
+                          ) *                                                 &
                              ( u(k_pp,j,i) + u(k_mmm,j,i) )                  &
                                       )
 
                 diss_d    = - ABS( w_comp ) * (                              &
-                          ( 10.0 * ibit17 * adv_mom_5                        &
-                       +     3.0 * ibit16 * adv_mom_3                        &
-                       +           ibit15 * adv_mom_1                        &
+                          ( 10.0_wp * ibit17 * adv_mom_5                        &
+                       +     3.0_wp * ibit16 * adv_mom_3                        &
+                       +              ibit15 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k,j,i)     - u(k-1,j,i)  )                  &
-                   -      (  5.0 * ibit17 * adv_mom_5                        &
-                       +           ibit16 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit17 * adv_mom_5                        &
+                       +              ibit16 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k+1,j,i)  - u(k_mm,j,i)  )                  &
-                   +      (        ibit17 * adv_mom_5                        &
+                   +      (           ibit17 * adv_mom_5                        &
                            ) *                                               &
                              ( u(k_pp,j,i) - u(k_mmm,j,i) )                  &
@@ -3702,14 +3708,14 @@
                 w_comp    = w(k,j,i) + w(k,j,i-1)
                 flux_t    = w_comp  * (                                      &
-                          ( 37.0 * ibit17 * adv_mom_5                        &
-                       +     7.0 * ibit16 * adv_mom_3                        &
-                       +           ibit15 * adv_mom_1                        &
+                          ( 37.0_wp * ibit17 * adv_mom_5                        &
+                       +     7.0_wp * ibit16 * adv_mom_3                        &
+                       +              ibit15 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k+1,j,i)  + u(k,j,i)     )                  &
-                   -      (  8.0 * ibit17 * adv_mom_5                        &
-                       +           ibit16 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit17 * adv_mom_5                        &
+                       +              ibit16 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-                   +      (        ibit17 * adv_mom_5                        &
+                   +      (           ibit17 * adv_mom_5                        &
                           ) *                                                &
                              ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
@@ -3717,14 +3723,14 @@
 
                 diss_t    = - ABS( w_comp ) * (                              &
-                          ( 10.0 * ibit17 * adv_mom_5                        &
-                       +     3.0 * ibit16 * adv_mom_3                        &
-                       +           ibit15 * adv_mom_1                        &
+                          ( 10.0_wp * ibit17 * adv_mom_5                        &
+                       +     3.0_wp * ibit16 * adv_mom_3                        &
+                       +              ibit15 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k+1,j,i)   - u(k,j,i)    )                  &
-                   -      (  5.0 * ibit17 * adv_mom_5                        &
-                       +           ibit16 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit17 * adv_mom_5                        &
+                       +              ibit16 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-                   +      (        ibit17 * adv_mom_5                        &
+                   +      (           ibit17 * adv_mom_5                        &
                            ) *                                               &
                              ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
@@ -3738,5 +3744,5 @@
                      +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
                                                                     * ddzw(k)  &
-                      ) * 0.5
+                      ) * 0.5_wp
 
                 tend(k,j,i) = - (                                              &
@@ -3751,8 +3757,8 @@
 !                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                     &
 !                              + ( flux_r    *                                 &
-!                                ( u_comp    - 2.0 * hom(k,1,1,0) )            &
+!                                ( u_comp    - 2.0_wp * hom(k,1,1,0) )            &
 !                              / ( u_comp    - gu + 1.0E-20_wp   )             &
 !                              +   diss_r    *                                 &
-!                                  ABS( u_comp    - 2.0 * hom(k,1,1,0) )       &
+!                                  ABS( u_comp    - 2.0_wp * hom(k,1,1,0) )       &
 !                              / ( ABS( u_comp    - gu ) + 1.0E-20_wp ) )      &
 !                              *   weight_substep(intermediate_timestep_count)
@@ -3840,6 +3846,6 @@
        REAL(wp), DIMENSION(nzb:nzt) ::  v_comp !:
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
 !
 !--    First compute the whole left boundary of the processor domain
@@ -3854,14 +3860,14 @@
              u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
              swap_flux_x_local_v(k,j) = u_comp * (                             &
-                                      ( 37.0 * ibit20 * adv_mom_5              &
-                                   +     7.0 * ibit19 * adv_mom_3              &
-                                   +           ibit18 * adv_mom_1              &
+                                      ( 37.0_wp * ibit20 * adv_mom_5              &
+                                   +     7.0_wp * ibit19 * adv_mom_3              &
+                                   +              ibit18 * adv_mom_1              &
                                       ) *                                      &
                                      ( v(k,j,i)   + v(k,j,i-1) )               &
-                               -      (  8.0 * ibit20 * adv_mom_5              &
-                                   +           ibit19 * adv_mom_3              &
+                               -      (  8.0_wp * ibit20 * adv_mom_5              &
+                                   +              ibit19 * adv_mom_3              &
                                       ) *                                      &
                                      ( v(k,j,i+1) + v(k,j,i-2) )               &
-                               +      (        ibit20 * adv_mom_5              &
+                               +      (           ibit20 * adv_mom_5              &
                                       ) *                                      &
                                      ( v(k,j,i+2) + v(k,j,i-3) )               &
@@ -3869,14 +3875,14 @@
 
               swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
-                                      ( 10.0 * ibit20 * adv_mom_5              &
-                                   +     3.0 * ibit19 * adv_mom_3              &
-                                   +           ibit18 * adv_mom_1              &
+                                      ( 10.0_wp * ibit20 * adv_mom_5              &
+                                   +     3.0_wp * ibit19 * adv_mom_3              &
+                                   +              ibit18 * adv_mom_1              &
                                       ) *                                      &
                                      ( v(k,j,i)   - v(k,j,i-1) )               &
-                               -      (  5.0 * ibit20 * adv_mom_5              &
-                                   +           ibit19 * adv_mom_3              &
+                               -      (  5.0_wp * ibit20 * adv_mom_5              &
+                                   +              ibit19 * adv_mom_3              &
                                       ) *                                      &
                                      ( v(k,j,i+1) - v(k,j,i-2) )               &
-                               +      (        ibit20 * adv_mom_5              &
+                               +      (           ibit20 * adv_mom_5              &
                                       ) *                                      &
                                      ( v(k,j,i+2) - v(k,j,i-3) )               &
@@ -3889,11 +3895,11 @@
              u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
              swap_flux_x_local_v(k,j) = u_comp * (                            &
-                             37.0 * ( v(k,j,i) + v(k,j,i-1)   )               &
-                           -  8.0 * ( v(k,j,i+1) + v(k,j,i-2) )               &
-                           +        ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
+                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )               &
+                           -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )               &
+                           +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
              swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
-                             10.0 * ( v(k,j,i) - v(k,j,i-1)   )               &
-                           -  5.0 * ( v(k,j,i+1) - v(k,j,i-2) )               &
-                           +        ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )               &
+                           -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )               &
+                           +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
 
           ENDDO
@@ -3912,14 +3918,14 @@
              v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
              swap_flux_y_local_v(k) = v_comp(k) * (                           &
-                                   ( 37.0 * ibit23 * adv_mom_5                &
-                                +     7.0 * ibit22 * adv_mom_3                &
-                                +           ibit21 * adv_mom_1                &
+                                   ( 37.0_wp * ibit23 * adv_mom_5                &
+                                +     7.0_wp * ibit22 * adv_mom_3                &
+                                +              ibit21 * adv_mom_1                &
                                    ) *                                        &
                                      ( v(k,j,i)   + v(k,j-1,i) )              &
-                            -      (  8.0 * ibit23 * adv_mom_5                &
-                                +           ibit22 * adv_mom_3                &
+                            -      (  8.0_wp * ibit23 * adv_mom_5                &
+                                +              ibit22 * adv_mom_3                &
                                    ) *                                        &
                                      ( v(k,j+1,i) + v(k,j-2,i) )              &
-                            +      (        ibit23 * adv_mom_5                &
+                            +      (           ibit23 * adv_mom_5                &
                                    ) *                                        &
                                      ( v(k,j+2,i) + v(k,j-3,i) )              &
@@ -3927,14 +3933,14 @@
 
              swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
-                                   ( 10.0 * ibit23 * adv_mom_5                &
-                                +     3.0 * ibit22 * adv_mom_3                &
-                                +           ibit21 * adv_mom_1                &
+                                   ( 10.0_wp * ibit23 * adv_mom_5                &
+                                +     3.0_wp * ibit22 * adv_mom_3                &
+                                +              ibit21 * adv_mom_1                &
                                    ) *                                        &
                                      ( v(k,j,i)   - v(k,j-1,i) )              &
-                            -      (  5.0 * ibit23 * adv_mom_5                &
-                                +           ibit22 * adv_mom_3                &
+                            -      (  5.0_wp * ibit23 * adv_mom_5                &
+                                +              ibit22 * adv_mom_3                &
                                    ) *                                        &
                                      ( v(k,j+1,i) - v(k,j-2,i) )              &
-                            +      (        ibit23 * adv_mom_5                &
+                            +      (           ibit23 * adv_mom_5                &
                                    ) *                                        &
                                      ( v(k,j+2,i) - v(k,j-3,i) )              &
@@ -3947,11 +3953,11 @@
              v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
              swap_flux_y_local_v(k) = v_comp(k) * (                           &
-                           37.0 * ( v(k,j,i) + v(k,j-1,i)   )                 &
-                         -  8.0 * ( v(k,j+1,i) + v(k,j-2,i) )                 &
-                         +        ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )                 &
+                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )                 &
+                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
              swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
-                           10.0 * ( v(k,j,i) - v(k,j-1,i)   )                 &
-                         -  5.0 * ( v(k,j+1,i) - v(k,j-2,i) )                 &
-                         +        ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )                 &
+                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )                 &
+                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
 
           ENDDO
@@ -3959,8 +3965,8 @@
           DO  j = nysv, nyn
 
-             flux_t(0) = 0.0
-             diss_t(0) = 0.0
-             flux_d    = 0.0
-             diss_d    = 0.0
+             flux_t(0) = 0.0_wp
+             diss_t(0) = 0.0_wp
+             flux_d    = 0.0_wp
+             diss_d    = 0.0_wp
 
              DO  k = nzb+1, nzb_max
@@ -3972,14 +3978,14 @@
                 u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
                 flux_r(k) = u_comp * (                                       &
-                          ( 37.0 * ibit20 * adv_mom_5                        &
-                       +     7.0 * ibit19 * adv_mom_3                        &
-                       +           ibit18 * adv_mom_1                        &
+                          ( 37.0_wp * ibit20 * adv_mom_5                        &
+                       +     7.0_wp * ibit19 * adv_mom_3                        &
+                       +              ibit18 * adv_mom_1                        &
                           ) *                                                &
                                  ( v(k,j,i+1) + v(k,j,i)   )                 &
-                   -      (  8.0 * ibit20 * adv_mom_5                        &
-                       +           ibit19 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit20 * adv_mom_5                        &
+                       +              ibit19 * adv_mom_3                        &
                           ) *                                                &
                                  ( v(k,j,i+2) + v(k,j,i-1) )                 &
-                   +      (        ibit20 * adv_mom_5                        &
+                   +      (           ibit20 * adv_mom_5                        &
                           ) *                                                &
                                  ( v(k,j,i+3) + v(k,j,i-2) )                 &
@@ -3987,14 +3993,14 @@
 
                 diss_r(k) = - ABS( u_comp ) * (                              &
-                          ( 10.0 * ibit20 * adv_mom_5                        &
-                       +     3.0 * ibit19 * adv_mom_3                        &
-                       +           ibit18 * adv_mom_1                        &
+                          ( 10.0_wp * ibit20 * adv_mom_5                        &
+                       +     3.0_wp * ibit19 * adv_mom_3                        &
+                       +              ibit18 * adv_mom_1                        &
                           ) *                                                &
                                  ( v(k,j,i+1) - v(k,j,i)  )                  &
-                   -      (  5.0 * ibit20 * adv_mom_5                        &
-                       +           ibit19 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit20 * adv_mom_5                        &
+                       +              ibit19 * adv_mom_3                        &
                           ) *                                                &
                                  ( v(k,j,i+2) - v(k,j,i-1) )                 &
-                   +      (        ibit20 * adv_mom_5                        &
+                   +      (           ibit20 * adv_mom_5                        &
                           ) *                                                &
                                  ( v(k,j,i+3) - v(k,j,i-2) )                 &
@@ -4007,14 +4013,14 @@
                 v_comp(k) = v(k,j+1,i) + v(k,j,i)
                 flux_n(k) = ( v_comp(k) - gv ) * (                           &
-                          ( 37.0 * ibit23 * adv_mom_5                        &
-                       +     7.0 * ibit22 * adv_mom_3                        &
-                       +           ibit21 * adv_mom_1                        &
+                          ( 37.0_wp * ibit23 * adv_mom_5                        &
+                       +     7.0_wp * ibit22 * adv_mom_3                        &
+                       +              ibit21 * adv_mom_1                        &
                           ) *                                                &
                                  ( v(k,j+1,i) + v(k,j,i)   )                 &
-                   -      (  8.0 * ibit23 * adv_mom_5                        &
-                       +           ibit22 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit23 * adv_mom_5                        &
+                       +              ibit22 * adv_mom_3                        &
                           ) *                                                &
                                  ( v(k,j+2,i) + v(k,j-1,i) )                 &
-                   +      (        ibit23 * adv_mom_5                        &
+                   +      (           ibit23 * adv_mom_5                        &
                           ) *                                                &
                                  ( v(k,j+3,i) + v(k,j-2,i) )                 &
@@ -4022,14 +4028,14 @@
 
                 diss_n(k) = - ABS( v_comp(k) - gv ) * (                      &
-                          ( 10.0 * ibit23 * adv_mom_5                        &
-                       +     3.0 * ibit22 * adv_mom_3                        &
-                       +           ibit21 * adv_mom_1                        &
+                          ( 10.0_wp * ibit23 * adv_mom_5                        &
+                       +     3.0_wp * ibit22 * adv_mom_3                        &
+                       +              ibit21 * adv_mom_1                        &
                           ) *                                                &
                                  ( v(k,j+1,i) - v(k,j,i)  )                  &
-                   -      (  5.0 * ibit23 * adv_mom_5                        &
-                       +           ibit22 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit23 * adv_mom_5                        &
+                       +              ibit22 * adv_mom_3                        &
                           ) *                                                &
                                  ( v(k,j+2,i) - v(k,j-1,i) )                 &
-                   +      (        ibit23 * adv_mom_5                        &
+                   +      (           ibit23 * adv_mom_5                        &
                           ) *                                                &
                                  ( v(k,j+3,i) - v(k,j-2,i) )                 &
@@ -4048,14 +4054,14 @@
                 w_comp    = w(k,j-1,i) + w(k,j,i)
                 flux_t(k) = w_comp  * (                                      &
-                          ( 37.0 * ibit26 * adv_mom_5                        &
-                       +     7.0 * ibit25 * adv_mom_3                        &
-                       +           ibit24 * adv_mom_1                        &
+                          ( 37.0_wp * ibit26 * adv_mom_5                        &
+                       +     7.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( v(k+1,j,i)   + v(k,j,i)    )                  &
-                   -      (  8.0 * ibit26 * adv_mom_5                        &
-                       +           ibit25 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( v(k_pp,j,i)  + v(k-1,j,i)  )                  &
-                   +      (        ibit26 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( v(k_ppp,j,i) + v(k_mm,j,i) )                  &
@@ -4063,14 +4069,14 @@
 
                 diss_t(k) = - ABS( w_comp ) * (                              &
-                          ( 10.0 * ibit26 * adv_mom_5                        &
-                       +     3.0 * ibit25 * adv_mom_3                        &
-                       +           ibit24 * adv_mom_1                        &
+                          ( 10.0_wp * ibit26 * adv_mom_5                        &
+                       +     3.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( v(k+1,j,i)   - v(k,j,i)    )                  &
-                   -      (  5.0 * ibit26 * adv_mom_5                        &
-                       +           ibit25 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( v(k_pp,j,i)  - v(k-1,j,i)  )                  &
-                   +      (        ibit26 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( v(k_ppp,j,i) - v(k_mm,j,i) )                  &
@@ -4084,5 +4090,5 @@
                      +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) )         &
                                                                   ) * ddzw(k) &
-                      ) * 0.5
+                      ) * 0.5_wp
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
@@ -4110,8 +4116,8 @@
                 sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                     &
                       + ( flux_n(k)                                           &
-                      * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                    &
+                      * ( v_comp(k) - 2.0_wp * hom(k,1,2,0) )                    &
                       / ( v_comp(k) - gv + 1.0E-20_wp )                       &
                       +   diss_n(k)                                           &
-                      *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )               &
+                      *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0) )               &
                       / ( ABS( v_comp(k) - gv ) +1.0E-20_wp ) )               &
                       *   weight_substep(intermediate_timestep_count)
